# joinstat.tcl for netbots.tcl v3.30
# designed to work with eggdrop 1.4.0 or higher
# Johoho's Eggdrop Page - http://johoho.tuts.net/eggdrop/
# joinstat.tcl copyright (c) 1999,2000 by Johoho <johoho@hojo-net.de>
# netbots.tcl copyright (c) 1998-2000 by slennox <slennox@egghelp.org>

## joinstat.tcl component script v1.02.0, 10.05.2000 ##

# History:
# 
# v1.00.0, 09.05.2000 - initial release, not public
# v1.01.0, 10.05.2000 - public release
# v1.02.0, 10.05.2000 - fixed a rather small bug

# thanks slennox for netbots.tcl

proc js_main {nick uhost hand chan} {
global botnet-nick nb_flag js_chans js_echans js_nick js_fast js_say js_serv js_type
  if {[lsearch -exact  [string tolower $js_nick] [string tolower $hand]] == -1} { return 0 }
  if {[lsearch -exact  [string tolower $js_say] [string tolower ${botnet-nick}]] == -1} { return 0 }
  if {$js_chans != ""} {
    if {![lsearch -exact $js_chans [string tolower $chan]] == -1} { return 0 }
  }
  if {$js_echans != ""} {
    if {![lsearch -exact $js_echans [string tolower $chan]] != -1} { return 0 }
  }
  set bots [expr [llength [bots]] + 1]
  set offline ""
  foreach netbot [userlist $nb_flag] {
    if {(![islinked $netbot]) && ([string tolower $netbot] != [string tolower ${botnet-nick}])} {
      lappend offline $netbot
    }
  }
  if {($js_type != "NOTICE") && ($js_type != "PRIVMSG")} {
    set $js_type "NOTICE"
  }
  if {$js_fast} {
    putserv "$js_type $nick : There are $bots [nb_plural bot $bots] on the botnet"
    putserv "$js_type $nick : $bots [nb_plural netbot $bots] ([llength $offline] offline or not linked: [join $offline ", "])"
  } else {
    puthelp "$js_type $nick : There are $bots [nb_plural bot $bots] on the botnet"
    puthelp "$js_type $nick : $bots [nb_plural netbot $bots] ([llength $offline] offline or not linked: [join $offline ", "])"
  }
  if {$js_serv} {
    nb_sendcmd * js_isonserv "$nick"
  }
}

proc js_isonserv {frombot arg} {
global server
  set nick [lindex $arg 0]
  if {$server == ""} {
    nb_sendcmd $frombot js_servreturn "$nick"
  }
}

proc js_servreturn {frombot arg} {
global js_fast js_type
  set nick [lindex $arg 0]
  if {($js_type != "NOTICE") && ($js_type != "PRIVMSG")} {
    set $js_type "NOTICE"
  }
  if {$js_fast} {
    putserv "$js_type $nick : $frombot is currently not connected to an irc server"
  } else {
    puthelp "$js_type $nick : $frombot is currently not connected to an irc server"
  }
}

set nb_netcmds(js_isonserv) "js_isonserv"
set nb_netcmds(js_servreturn) "js_servreturn"

if {![info exists js_flag]} {
  set js_flag n
} else {
  catch {unbind join n * js_main}
}

bind join $js_flag * js_main
